program puissance_4;

uses crt,ecr_plus;

type
   jeu = record
	    a : array[1..7,1..6] of integer;
	 end;

var
   tablo   : jeu;
   i,j,k   : integer;
   termine : boolean;
   

procedure indente;
var i:integer;
begin
for i:=1 to 30 do
write(' ');
end; { indente }



procedure initialisetab(var tablo : jeu);
var i,j	: integer;
begin
   for j:=1 to 6 do
   begin
      for i:=1 to 7 do
      begin
	 tablo.a[i,j]:=0;
      end;
   end;
end; { initialisetab }



function correspond(n : integer):string;
begin
   if n=0 then
      correspond:=' ';
   if n=1 then
      correspond:='x';
   if n=2 then
      correspond:='o';
end; { correspond }



procedure affiche_tab(tablo :jeu);
var  i,j : integer;
     car : string;
begin
   indente;
   writeln('  Puissance 4');
   indente;
   writeln(' 1 2 3 4 5 6 7');
   indente;
   writeln('_______________');
   for j:=1 to 6 do
   begin
      indente;
      for i:=1 to 7 do
      begin
	 write('|');
	 car := correspond(tablo.a[i,j]);
	 if car = 'x' then
	  ecrire_perso(car,blue,clBackStd)
	 else
	  ecrire_perso(car,magenta,clBackStd)
      end;
      writeln('|');
   end;
   indente;
   writeln('===============');
end; { affiche_tab }



function chercheplace(tab :jeu; col : integer):integer;
var i : integer;
begin
   i:=6;
   while  (tab.a[col,i]<>0) and (i>0)do
   begin
      i:=i-1;
   end;
   if i>0 then
      chercheplace:=i
   else
      chercheplace:=-1;
end; { chercheplace }


function gauche(tab : jeu ; i,k:integer):boolean;
var j,cpt : integer;
begin
   cpt:=0;
   for j:=1 to 3 do
   begin
      if tab.a[i-j,k]=tab.a[i,k] then cpt:=cpt+1
   end;
   if cpt=3 then gauche:=true
   else gauche:=false;
end; { gauche }


function droite(tab : jeu ; i,k:integer):boolean;
var j,cpt : integer;
begin
   cpt:=0;
   for j:=1 to 3 do
   begin
      if tab.a[i+j,k]=tab.a[i,k] then cpt:=cpt+1
   end;
   if cpt=3 then droite:=true
   else droite:=false;
end; { droite }


function haut(tab : jeu ; i,k:integer):boolean;
var j,cpt : integer;
begin
   cpt:=0;
   for j:=1 to 3 do
   begin
      if tab.a[i,k+j]=tab.a[i,k] then cpt:=cpt+1
   end;
   if cpt=3 then haut:=true
   else haut:=false;
end; { haut }


function bas(tab : jeu ; i,k:integer):boolean;
var j,cpt : integer;
begin
   cpt:=0;
   for j:=1 to 3 do
   begin
      if tab.a[i,k-j]=tab.a[i,k] then cpt:=cpt+1
   end;
   if cpt=3 then bas:=true
   else bas:=false;
end; { bas }


function diagh(tab : jeu ; i,k:integer):boolean;
var j,cpt : integer;
begin
   cpt:=0;
   for j:=1 to 3 do
   begin
      if tab.a[i-j,k+j]=tab.a[i,k] then cpt:=cpt+1
   end;
   if cpt=3 then diagh:=true
   else diagh:=false;  
end; { diagh }


function diagb(tab : jeu ; i,k:integer):boolean;
var j,cpt : integer;
begin
   cpt:=0;
   for j:=1 to 3 do
   begin
      if tab.a[i-j,k-j]=tab.a[i,k] then cpt:=cpt+1
   end;
   if cpt=3 then diagb:=true
   else diagb:=false;   
end; { diagb }


function diadh(tab : jeu ; i,k:integer):boolean;
var j,cpt : integer;
begin
   cpt:=0;
   for j:=1 to 3 do
   begin
      if tab.a[i+j,k+j]=tab.a[i,k] then cpt:=cpt+1
   end;
   if cpt=3 then diadh:=true
   else diadh:=false;  
end;


function diadb(tab : jeu ; i,k:integer):boolean;
var j,cpt : integer;
begin
   cpt:=0;
   for j:=1 to 3 do
   begin
      if tab.a[i-j,k-j]=tab.a[i,k] then cpt:=cpt+1
   end;
   if cpt=3 then diadb:=true
   else diadb:=false;     
end; { diadb }



function verification(tab : jeu ; i,k:integer):boolean;
var boule : boolean;
begin
   boule:=gauche(tablo,i,k);
   if boule=false then
      boule:=droite(tablo,i,k);
   if boule=false then
      boule:=haut(tablo,i,k);
   if boule=false then
      boule:=bas(tablo,i,k);
   if boule=false then
      boule:=diagh(tablo,i,k);
   if boule=false then
      boule:=diagb(tablo,i,k);
   if boule=false then
      boule:=diadh(tablo,i,k);
   if boule=false then
      boule:=diadb(tablo,i,k);
   verification:=boule;
end; { verification }



{ ******* programme principal **** }
begin

   initialiser;

   initialisetab(tablo);
   affiche_tab(tablo);
   termine:=false;
   j:=1;
   while not(termine) do
   begin
      writeln;
      write('C''est au  joueur ',j,' de jouer. Saisissez votre numero  de colonne ( 1 - 7 ) : ');
      i := str2int(controler_saisie(1,7));
      clrscr;
      k:=chercheplace(tablo,i);
      if k=-1 then
      begin
	writeln('Arrete de boire !!  La colonne est remplie');
      end
      else
      begin
	 tablo.a[i,k]:=j;
	 if j=1 then j:=2
	 else j:=1;
      end;
      affiche_tab(tablo);
      termine:=verification(tablo,i,k);
   end;
   if j=1 then j:=2
   else j:=1;
   indente;
   ecrire_perso('******************',yellow,clBackStd);writeln;
   indente;
   ecrire_perso('   PUISSANCE 4',yellow,clBackStd);writeln;
   indente;
   ecrire_perso('******************',yellow,clBackStd);writeln;
   writeln('Le joueur ',j,' a remporte la victoire, felicitation.');
   finir_ligne;
   restaurer;
end.{ puissance_4 }